/* ******************************************************************** */
/*               Algoritmo Branch-And-Bound Secuencial                  */
/* ******************************************************************** */
#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <mpi.h>
#include "libbb.h"

using namespace std;

unsigned int NCIUDADES;

int main (int argc, char **argv) {
        MPI::Init(argc,argv);
	if (argc < 2) {
            cerr << "La sintaxis es: bbseq <archivo>" << endl;
            exit(1);
        }

        {
            // HACK
            std::ifstream is (argv [1]);
            is >> NCIUDADES;
            std::cout << "NCIUDADES: " << NCIUDADES << std::endl;
        }
	int** tsp0 = reservarMatrizCuadrada(NCIUDADES);
	tNodo	nodo,         // nodo a explorar
			lnodo,        // hijo izquierdo
			rnodo,        // hijo derecho
			solucion;     // mejor solucion
	bool activo,        // condicion de fin
		nueva_U;       // hay nuevo valor de c.s.
	int  U;             // valor de c.s.
	tPila pila;         // pila de nodos a explorar

	U = INFINITO;                  // inicializa cota superior
	InicNodo (&nodo);              // inicializa estructura nodo
	PilaInic (&pila);              // inicializa pila
	LeerMatriz (argv[1], tsp0);    // lee matriz de fichero
	activo = !Inconsistente(tsp0);
        double t=MPI::Wtime();   
	while (activo) {       // ciclo del Branch&Bound
		Ramifica (&nodo, &lnodo, &rnodo, tsp0);
		nueva_U = false;
		if (Solucion(&rnodo)) {
			if (rnodo.ci < U) {    // se ha encontrado una solucion mejor
				U = rnodo.ci;
				nueva_U = true;
				CopiaNodo (&rnodo, &solucion);
			}
		}
		else {                    //  no es un nodo solucion
			if (rnodo.ci < U) {     //  cota inferior menor que cota superior
				if (!PilaPush (&pila, &rnodo)) {
					printf ("Error: pila agotada\n");
					liberarMatriz(tsp0);
					exit (1);
				}
			}
		}
		if (Solucion(&lnodo)) {
			if (lnodo.ci < U) {    // se ha encontrado una solucion mejor
				U = lnodo.ci;
				nueva_U = true;
				CopiaNodo (&lnodo,&solucion);
			}
		}
		else {                     // no es nodo solucion
			if (lnodo.ci < U) {      // cota inferior menor que cota superior
				if (!PilaPush (&pila, &lnodo)) {
					printf ("Error: pila agotada\n");
					liberarMatriz(tsp0);
					exit (1);
				}
			}
		}
		if (nueva_U) PilaAcotar (&pila, U);
		activo = PilaPop (&pila, &nodo);
	}
        t=MPI::Wtime()-t;
        MPI::Finalize();
	printf ("Solucion: \n");
	EscribeNodo(&solucion);
        cout<< "Tiempo gastado= "<<t<<endl<<endl;
	liberarMatriz(tsp0);
}


